=== lib/MC/CMakeLists.txt ===
add_llvm_library(LLVMMC
  ELFObjectWriter.cpp
  MCAsmBackend.cpp
  MCAsmInfo.cpp
  MCAsmInfoCOFF.cpp
  MCAsmInfoDarwin.cpp
  MCAsmStreamer.cpp
  MCAssembler.cpp
  MCAtom.cpp
  MCCodeEmitter.cpp
  MCCodeGenInfo.cpp
  MCContext.cpp
  MCDisassembler.cpp
  MCDwarf.cpp
  MCELF.cpp
  MCELFObjectTargetWriter.cpp
  MCELFStreamer.cpp
  MCFunction.cpp
  MCExpr.cpp
  MCExternalSymbolizer.cpp
  MCInst.cpp
  MCInstPrinter.cpp
  MCInstrAnalysis.cpp
  MCLabel.cpp
  MCMachOStreamer.cpp
  MCMachObjectTargetWriter.cpp
  MCModule.cpp
  MCNullStreamer.cpp
  MCObjectFileInfo.cpp
  MCObjectDisassembler.cpp
  MCObjectStreamer.cpp
  MCObjectSymbolizer.cpp
  MCObjectWriter.cpp
  MCPureStreamer.cpp
  MCRegisterInfo.cpp
  MCRelocationInfo.cpp
  MCSection.cpp
  MCSectionCOFF.cpp
  MCSectionELF.cpp
  MCSectionMachO.cpp
  MCStreamer.cpp
  MCSubtargetInfo.cpp
  MCSymbol.cpp
  MCSymbolizer.cpp
  MCValue.cpp
  MCWin64EH.cpp
  MachObjectWriter.cpp
  SubtargetFeature.cpp
  WinCOFFObjectWriter.cpp
  WinCOFFStreamer.cpp
  )

add_subdirectory(MCParser)
add_subdirectory(MCDisassembler)
