=== debian/changelog ===
llvm-toolchain-snapshot (1:3.4~svn183914-1) unstable; urgency=low

  * New snapshot release
  * Upload to unstable (will be blocked by a RC bug)
  * Sync changes from llvm-toolchain-3.3:
    - Introduce cpp11-migrate-3.4 and clang-format-3.4
    - Install the vim llvm script at the right place

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 13 Jun 2013 18:47:08 +0200

llvm-toolchain-snapshot (1:3.4~svn182733-1~exp1) experimental; urgency=low

   * New snapshot release (3.4 release)
   * Add a symlink of libLLVM-3.4.so.1 to usr/lib/llvm-3.4/lib/libLLVM-3.4.so
       to fix make the llvm-config-3.4 --libdir work (Closes: #708677)
     * Various packages rename to allow co installations:
       * libclang1 => libclang1-3.4
       * libclang1-dbg => libclang1-3.4-dbg
       * libclang-dev => libclang-3.4-dev
       * libclang-common-dev => libclang-common-3.4-dev

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 27 May 2013 15:01:57 +0200

llvm-toolchain-snapshot (1:3.3~svn179851-1~exp1) experimental; urgency=low

  * Draft of a snapshot release (3.3)
  * Enable r600 experimental backend
  * Improve the dependencies:
    * clang-3.3 depends on the exact same libllvm3.3 release
    * idem for lldb-3.3

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 19 Apr 2013 09:31:38 +0200

llvm-toolchain-3.2 (1:3.2repack-1~exp3) experimental; urgency=low

  * Build using binutls-gold to improve the quality of the binaries.
    See: http://allievi.sssup.it/techblog/?p=791
  * Detect the vendor (Debian or Ubuntu) and update the configuration
  * Port to powerpcspe. Thanks to Roland Stigge (Closes: #701587)
    See: 31-powerpcspe.diff
  * Fix the path detection of scan-build (Closes: #698352)
    See: 32-scan-build-path.diff

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 14 Mar 2013 17:47:12 +0100

llvm-toolchain-3.2 (1:3.2repack-1~exp2) experimental; urgency=low

  * Install the python files for lldb. Thanks to Daniel Malea for spotting this.
  * Update of the clean target
  * Introduce an epoch to match the changes in bug #699899

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 13 Feb 2013 12:22:30 +0100

llvm-toolchain-3.2 (3.2repack-1~exp1) experimental; urgency=low

  * Build the whole LLVM toolchain at once. This includes:
    - LLVM
    - Clang
    - compiler-rt
    - lldb
    - polly
  * Also install clang-check & clang-tblgen in the clang-3.2 package
  * Fix the patch detection of clang from scan-build (Closes: #698352)
  * debian/patches/0050-powerpcspe-fp.diff: Add, hopefully fix FTBFS on
    powerpcspe, by disabling save / restore of floating point registers which
    don't exist on powerpcspe. Thanks to Roland Stigge for the patch.
    (Closes: #696474)
  * libLLVM-3.2.so.1 is now shipped only once (Closes: #696913)
  * Enable RTTI (Closes: #697754)
  * Introduce lldb as a new package (Closes: #698601)
  * Add a script pollycc which will call clang with the right arguments.
  * Use __builtin___clear_cache on ARM to fix a clang bug.
    Thanks to Matthias Klose.

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 09 Feb 2013 12:14:10 +0100
